// ActualLineGraphView.h
// Copyright(C) 1999 by Kiyoshi Kobayashi. All rights reserved.
//
//
#ifndef _ACTUAL_LINE_GRAPH_VIEW_H_
#define _ACTUAL_LINE_GRAPH_VIEW_H_

#include <View.h>
#include <Rect.h>
#include <List.h>
#include <Point.h>
#include <PopUpMenu.h>

// This class actually draws the lines and pops up the menu when
// the user clicks it.
//
class _EXPORT ActualLineGraphView : public BView {
public:
	ActualLineGraphView(BRect frame, const char *name,
			    float maximum = 0.0f);
	ActualLineGraphView(BMessage *archive);
	~ActualLineGraphView();
	
	// Updates the lines.
	void Update(float rate);

	// BView method override
	void AttachedToWindow();
	void FrameResized(float width, float height);
	void Draw(BRect updateRect);
	void MouseDown(BPoint point);
	
	// Archivable
	status_t Archive(BMessage *archive, bool deep) const;
	static BArchivable *Instantiate(BMessage *archive);
	
private:
	ActualLineGraphView(const ActualLineGraphView &);
	ActualLineGraphView &operator=(const ActualLineGraphView &) {
	    return *this; };
	
	void RedrawAllLines();
	void UpdateLines();
	BPopUpMenu *GetMenu();
	
	static bool Regurate(void *item, void *rate);
	
	int32 num;
	float max;
	float defaultMax;
	BPopUpMenu *menu;
	BList list;
};

#endif /* _ACTUAL_LINE_GRAPH_VIEW_H_ */
