// SysInfoDeltaGenerator.h
// Copyright(C) 1999 by Kiyoshi Kobayashi. All rights reserved.
//

#ifndef _SYS_INFO_DELTA_GENERATOR_H_
#define _SYS_INFO_DELTA_GENERATOR_H_

#include <Locker.h>
#include <List.h>
#include "SysInfo.h"
#include "SysInfoObserver.h"

//
//
class SysInfoDeltaGenerator {
  public:
	static SysInfoDeltaGenerator *GetGenerator();
	
	bool Register(SysInfoObserver *obs);
	bool Unregister(SysInfoObserver *obs);

	void Generate();
	
  private:
	// To privent regular construction and destruction.
	SysInfoDeltaGenerator();
	~SysInfoDeltaGenerator();
	
	// To disallow accidential copy construction.
	SysInfoDeltaGenerator(const SysInfoDeltaGenerator &) {};

	static SysInfoDeltaGenerator *gen;	// To keep the pointer to the
										// Singleton generator.
	static BLocker	genLock;	// To protect "gen" pointer.
		
	SysInfo	pre;	// To keep previouse SysInfo.
	BList	list;	// To keep all observers.
	BLocker	lock;	// To protect "this".
};

#endif /* _SYS_INFO_DELTA_GENERATOR_H_ */
