// BeYapWin.cpp
// Copyright(C) 1999 by Kiyoshi Kobayashi. All rights reserved.
//
//
#include <stdio.h>
#include <string.h>
#include <Application.h>
#include <Dragger.h>
#include <Debug.h>
#include <SupportDefs.h>

#include "BeYapWin.h"

BeYapWin::BeYapWin(BRect frame, Profile *p)
	: BWindow(frame, "BeYap", B_TITLED_WINDOW_LOOK, B_NORMAL_WINDOW_FEEL, 0),
	  profile(p) {
	frame.OffsetTo(0.0f, 0.0f);
	mb = new MeterBaseView(frame, profile->GetLayoutType(),
							profile->GetAllWorkspaces(),
							profile->GetInterval());
	AddChild(mb);
}

BeYapWin::~BeYapWin() {}

BeYapWin::BeYapWin(const BeYapWin &)
	: BWindow(BRect(100.0f, 100.0f, 200.0f, 200.0f), "BeYap",
	B_TITLED_WINDOW_LOOK, B_NORMAL_WINDOW_FEEL, 0) {}

bool
BeYapWin::QuitRequested() {
	CommitProfile();
	be_app->PostMessage(B_QUIT_REQUESTED, be_app);
	return true;
}

void
BeYapWin::CommitProfile() {
	ASSERT(profile != NULL);
	ASSERT(profile->InitCheck() == B_NO_ERROR);
	profile->SetFrame(Frame());
	profile->SetLayoutType(mb->GetLayoutType());
	profile->SetAllWorkspaces(mb->GetAllWorkspaces());
	profile->SetInterval(mb->GetInterval());
	status_t ret = profile->Commit();
	ASSERT(ret == B_NO_ERROR);
}
